Index: /nanovis/branches/1.1/Command.cpp
===================================================================
--- /nanovis/branches/1.1/Command.cpp	(revision 4611)
+++ /nanovis/branches/1.1/Command.cpp	(revision 4612)
@@ -26,12 +26,6 @@
  *        o Use Tcl command option parser to reduce size of procedures, remove
  *          lots of extra error checking code. (almost there)
- *        o Convert GetVolumeIndices to GetVolumes.  Goal is to remove
- *          all references of Nanovis::volume[] from this file.  Don't
- *          want to know how volumes are stored. Same for heightmaps.
- *        o Rationalize volume id scheme. Right now it's the index in
- *          the vector. 1) Use a list instead of a vector. 2) carry
- *          an id field that's a number that gets incremented each new volume.
  *        o Add bookkeeping for volumes, heightmaps, flows, etc. to track
- *          1) id #  2) simulation # 3) include/exclude.  The include/exclude
+ *          1) simulation # 2) include/exclude.  The include/exclude
  *          is to indicate whether the item should contribute to the overall
  *          limits of the axes.
@@ -45,6 +39,4 @@
 
 #include <RpField1D.h>
-#include <RpFieldRect3D.h>
-#include <RpFieldPrism3D.h>
 #include <RpEncode.h>
 #include <RpOutcome.h>
@@ -55,4 +47,5 @@
 #include "nanovis.h"
 #include "CmdProc.h"
+#include "FlowCmd.h"
 #include "Trace.h"
 #ifdef USE_POINTSET_RENDERER
@@ -109,17 +102,4 @@
 }";
 
-static Tcl_ObjCmdProc AxisCmd;
-static Tcl_ObjCmdProc CameraCmd;
-static Tcl_ObjCmdProc CutplaneCmd;
-extern Tcl_AppInitProc FlowCmdInitProc;
-static Tcl_ObjCmdProc GridCmd;
-static Tcl_ObjCmdProc LegendCmd;
-static Tcl_ObjCmdProc ScreenCmd;
-static Tcl_ObjCmdProc SnapshotCmd;
-static Tcl_ObjCmdProc TransfuncCmd;
-static Tcl_ObjCmdProc Unirect2dCmd;
-static Tcl_ObjCmdProc UpCmd;
-static Tcl_ObjCmdProc VolumeCmd;
-
 bool
 GetBooleanFromObj(Tcl_Interp *interp, Tcl_Obj *objPtr, bool *boolPtr)
@@ -2228,4 +2208,2 @@
     return interp;
 }
-
-
Index: /nanovis/branches/1.1/Command.h
===================================================================
--- /nanovis/branches/1.1/Command.h	(revision 4612)
+++ /nanovis/branches/1.1/Command.h	(revision 4612)
@@ -0,0 +1,37 @@
+/* -*- mode: c++; c-basic-offset: 4; indent-tabs-mode: nil -*- */
+/*
+ * Copyright (c) 2004-2013  HUBzero Foundation, LLC
+ *
+ * Authors:
+ *   Wei Qiao <qiaow@purdue.edu>
+ *   Insoo Woo <iwoo@purdue.edu>
+ *   George A. Howlett <gah@purdue.edu>
+ *   Leif Delgass <ldelgass@purdue.edu>
+ */
+#ifndef COMMAND_H
+#define COMMAND_H
+
+#include <tcl.h>
+
+namespace Rappture {
+class Buffer;
+}
+class Volume;
+
+extern int GetAxisFromObj(Tcl_Interp *interp, Tcl_Obj *objPtr,
+                          int *axisVal);
+
+extern int GetBooleanFromObj(Tcl_Interp *interp, Tcl_Obj *objPtr,
+                             bool *boolVal);
+
+extern int GetDataStream(Tcl_Interp *interp, Rappture::Buffer &buf, int nBytes);
+
+extern int GetFloatFromObj(Tcl_Interp *interp, Tcl_Obj *objPtr,
+                           float *floatVal);
+
+extern int GetVolumeFromObj(Tcl_Interp *interp, Tcl_Obj *objPtr,
+                            Volume **volume);
+
+extern Tcl_Interp *initTcl();
+
+#endif
Index: /nanovis/branches/1.1/Doxyfile.in
===================================================================
--- /nanovis/branches/1.1/Doxyfile.in	(revision 4611)
+++ /nanovis/branches/1.1/Doxyfile.in	(revision 4612)
@@ -599,5 +599,5 @@
 # subdirectory from a directory tree whose root is specified with the INPUT tag.
 
-EXCLUDE                = @srcdir@/newmat11 @srcdir@/CircularQueue.h @srcdir@/ParticleEmitter.h @srcdir@/ParticleEmitter.cpp @srcdir@/ParticleSystem.h @srcdir@/ParticleSystem.cpp @srcdir@/ParticleSystemFactory.h @srcdir@/ParticleSystemFactory.cpp @srcdir@/BucketSort.h @srcdir@/BucketSort.cpp @srcdir@/PCASplit.h @srcdir@/PCASplit.cpp @srcdir@/PointSet.h @srcdir@/PointSet.cpp @srcdir@/PointSetRenderer.h @srcdir@/PointSetRenderer.cpp @srcdir@/PointShader.h @srcdir@/PointShader.cpp @srcdir@/NvVectorField.h @srcdir@/NvVectorField.cpp @srcdir@/NvFlowVisRenderer.h @srcdir@/NvFlowVisRenderer.cpp
+EXCLUDE                = @srcdir@/newmat11 @srcdir@/CircularQueue.h @srcdir@/ParticleEmitter.h @srcdir@/ParticleEmitter.cpp @srcdir@/ParticleSystem.h @srcdir@/ParticleSystem.cpp @srcdir@/ParticleSystemFactory.h @srcdir@/ParticleSystemFactory.cpp @srcdir@/BucketSort.h @srcdir@/BucketSort.cpp @srcdir@/PCASplit.h @srcdir@/PCASplit.cpp @srcdir@/PointSet.h @srcdir@/PointSet.cpp @srcdir@/PointSetRenderer.h @srcdir@/PointSetRenderer.cpp @srcdir@/PointShader.h @srcdir@/PointShader.cpp
 
 # The EXCLUDE_SYMLINKS tag can be used select whether or not files or
Index: /nanovis/branches/1.1/Flow.cpp
===================================================================
--- /nanovis/branches/1.1/Flow.cpp	(revision 4612)
+++ /nanovis/branches/1.1/Flow.cpp	(revision 4612)
@@ -0,0 +1,441 @@
+/* -*- mode: c++; c-basic-offset: 4; indent-tabs-mode: nil -*- */
+/*
+ * Copyright (c) 2004-2013  HUBzero Foundation, LLC
+ *
+ * Authors:
+ *   Wei Qiao <qiaow@purdue.edu>
+ *   Insoo Woo <iwoo@purdue.edu>
+ *   George A. Howlett <gah@purdue.edu>
+ *   Leif Delgass <ldelgass@purdue.edu>
+ */
+
+#include <tcl.h>
+
+#include <vrmath/Vector3f.h>
+
+#include "nanovis.h"
+#include "Flow.h"
+#include "FlowCmd.h"
+#include "FlowTypes.h"
+#include "FlowParticles.h"
+#include "FlowBox.h"
+#include "NvLIC.h"
+#include "VelocityArrowsSlice.h"
+#include "NvParticleRenderer.h"
+#include "Switch.h"
+#include "Unirect.h"
+#include "Volume.h"
+#include "Trace.h"
+#include "TransferFunction.h"
+
+using namespace vrmath;
+
+Flow::Flow(Tcl_Interp *interp, const char *name) :
+    _interp(interp),
+    _name(name),
+    _data(NULL),
+    _volume(NULL)
+{
+    memset(&_sv, 0, sizeof(FlowValues));
+    _sv.sliceVisible = 1;
+    _sv.transferFunction = NanoVis::getTransferFunction("default");
+
+    _cmdToken = Tcl_CreateObjCommand(_interp, (char *)name, 
+                                     (Tcl_ObjCmdProc *)FlowInstObjCmd,
+                                     this, FlowInstDeleteProc);
+}
+
+Flow::~Flow()
+{
+    TRACE("Enter");
+
+    Rappture::FreeSwitches(_switches, &_sv, 0);
+
+    if (_data != NULL) {
+        delete _data;
+    }
+    if (_volume != NULL) {
+        NanoVis::removeVolume(_volume);
+        _volume = NULL;
+    }
+    for (BoxHashmap::iterator itr = _boxTable.begin();
+         itr != _boxTable.end(); ++itr) {
+        delete itr->second;
+    }
+    _boxTable.clear();
+    for (ParticlesHashmap::iterator itr = _particlesTable.begin();
+         itr != _particlesTable.end(); ++itr) {
+        delete itr->second;
+    }
+    _particlesTable.clear();
+}
+
+void
+Flow::getBounds(Vector3f& min,
+                Vector3f& max,
+                bool onlyVisible)
+{
+    TRACE("Enter");
+
+    if (onlyVisible && !visible())
+        return;
+
+#if 0  // Using volume bounds instead of these
+    if (isDataLoaded()) {
+        Vector3f umin, umax;
+        Rappture::Unirect3d *unirect = data();
+        unirect->getWorldSpaceBounds(umin, umax);
+        if (min.x > umin.x) {
+            min.x = umin.x;
+        }
+        if (max.x < umax.x) {
+            max.x = umax.x;
+        }
+        if (min.y > umin.y) {
+            min.y = umin.y;
+        }
+        if (max.y < umax.y) {
+            max.y = umax.y;
+        }
+        if (min.z > umin.z) {
+            min.z = umin.z;
+        }
+        if (max.z < umax.z) {
+            max.z = umax.z;
+        }
+    }
+#endif
+    for (BoxHashmap::iterator itr = _boxTable.begin();
+         itr != _boxTable.end(); ++itr) {
+        FlowBox *box = itr->second;
+        if (!onlyVisible || box->visible()) {
+            Vector3f fbmin, fbmax;
+            box->getWorldSpaceBounds(fbmin, fbmax,
+                                     getVolume());
+            if (min.x > fbmin.x) {
+                min.x = fbmin.x;
+            }
+            if (max.x < fbmax.x) {
+                max.x = fbmax.x;
+            }
+            if (min.y > fbmin.y) {
+                min.y = fbmin.y;
+            }
+            if (max.y < fbmax.y) {
+                max.y = fbmax.y;
+            }
+            if (min.z > fbmin.z) {
+                min.z = fbmin.z;
+            }
+            if (max.z < fbmax.z) {
+                max.z = fbmax.z;
+            }
+        }
+    }
+}
+
+float
+Flow::getRelativePosition(FlowPosition *position)
+{
+    if (position->flags == RELPOS) {
+        return position->value;
+    }
+    switch (position->axis) {
+    case AXIS_X:  
+        return (position->value - NanoVis::xMin) / 
+            (NanoVis::xMax - NanoVis::xMin); 
+    case AXIS_Y:  
+        return (position->value - NanoVis::yMin) / 
+            (NanoVis::yMax - NanoVis::yMin); 
+    case AXIS_Z:  
+        return (position->value - NanoVis::zMin) / 
+            (NanoVis::zMax - NanoVis::zMin); 
+    }
+    return 0.0;
+}
+
+float
+Flow::getRelativePosition() 
+{
+    return getRelativePosition(&_sv.slicePos);
+}
+
+void
+Flow::resetParticles()
+{
+    for (ParticlesHashmap::iterator itr = _particlesTable.begin();
+         itr != _particlesTable.end(); ++itr) {
+        itr->second->reset();
+    }
+}
+
+void
+Flow::advect()
+{
+    for (ParticlesHashmap::iterator itr = _particlesTable.begin();
+         itr != _particlesTable.end(); ++itr) {
+        if (itr->second->visible()) {
+            itr->second->advect();
+        }
+    }
+}
+
+void
+Flow::render()
+{
+    for (ParticlesHashmap::iterator itr = _particlesTable.begin();
+         itr != _particlesTable.end(); ++itr) {
+        if (itr->second->visible()) {
+            itr->second->render();
+        }
+    }
+    renderBoxes();
+}
+
+FlowParticles *
+Flow::createParticles(const char *particlesName)
+{
+    ParticlesHashmap::iterator itr = _particlesTable.find(particlesName);
+    if (itr != _particlesTable.end()) {
+        TRACE("Deleting existing particle injection plane '%s'", particlesName);
+        delete itr->second;
+        _particlesTable.erase(itr);
+    }
+    FlowParticles *particles = new FlowParticles(particlesName);
+    _particlesTable[particlesName] = particles;
+    return particles;
+}
+
+FlowParticles *
+Flow::getParticles(const char *particlesName)
+{
+    ParticlesHashmap::iterator itr;
+    itr = _particlesTable.find(particlesName);
+    if (itr == _particlesTable.end()) {
+        TRACE("Can't find particle injection plane '%s' in '%s'", particlesName, name());
+        return NULL;
+    }
+    return itr->second;
+}
+
+void
+Flow::deleteParticles(const char *particlesName)
+{
+    ParticlesHashmap::iterator itr = _particlesTable.find(particlesName);
+    if (itr == _particlesTable.end()) {
+        TRACE("Can't find particle injection plane '%s' in '%s'", particlesName, name());
+        return;
+    }
+    delete itr->second;
+    _particlesTable.erase(itr);
+}
+
+void
+Flow::getParticlesNames(std::vector<std::string>& names)
+{
+    for (ParticlesHashmap::iterator itr = _particlesTable.begin();
+         itr != _particlesTable.end(); ++itr) {
+        names.push_back(std::string(itr->second->name()));
+    }
+}
+
+FlowBox *
+Flow::createBox(const char *boxName)
+{
+    BoxHashmap::iterator itr = _boxTable.find(boxName);
+    if (itr != _boxTable.end()) {
+        TRACE("Deleting existing box '%s'", boxName);
+        delete itr->second;
+        _boxTable.erase(itr);
+    }
+    FlowBox *box = new FlowBox(boxName);
+    _boxTable[boxName] = box;
+    return box;
+}
+
+FlowBox *
+Flow::getBox(const char *boxName)
+{
+    BoxHashmap::iterator itr = _boxTable.find(boxName);
+    if (itr == _boxTable.end()) {
+        TRACE("Can't find box '%s' in '%s'", boxName, name());
+        return NULL;
+    }
+    return itr->second;
+}
+
+void
+Flow::deleteBox(const char *boxName)
+{
+    BoxHashmap::iterator itr = _boxTable.find(boxName);
+    if (itr == _boxTable.end()) {
+        TRACE("Can't find box '%s' in '%s'", boxName, name());
+        return;
+    }
+    delete itr->second;
+    _boxTable.erase(itr);
+}
+
+void Flow::getBoxNames(std::vector<std::string>& names)
+{
+    for (BoxHashmap::iterator itr = _boxTable.begin();
+         itr != _boxTable.end(); ++itr) {
+        names.push_back(std::string(itr->second->name()));
+    }
+}
+
+void
+Flow::initializeParticles()
+{
+    for (ParticlesHashmap::iterator itr = _particlesTable.begin();
+         itr != _particlesTable.end(); ++itr) {
+        itr->second->initialize();
+    }
+}
+
+bool
+Flow::scaleVectorField()
+{
+    if (_volume != NULL) {
+        TRACE("Removing existing volume: %s", _volume->name());
+        NanoVis::removeVolume(_volume);
+        _volume = NULL;
+    }
+    float *vdata = getScaledVector();
+    if (vdata == NULL) {
+        return false;
+    }
+    Volume *volume = makeVolume(vdata);
+    delete [] vdata;
+    if (volume == NULL) {
+        return false;
+    }
+    _volume = volume;
+
+    Vector3f scale = volume->getPhysicalScaling();
+    Vector3f location = _volume->location();
+
+    if (NanoVis::licRenderer != NULL) {
+        NanoVis::licRenderer->
+            setVectorField(_volume->textureID(),
+                           location,
+                           scale.x,
+                           scale.y,
+                           scale.z,
+                           _volume->wAxis.max());
+        setCurrentPosition();
+        setAxis();
+        setActive();
+    }
+
+    if (NanoVis::velocityArrowsSlice != NULL) {
+        NanoVis::velocityArrowsSlice->
+            setVectorField(_volume->textureID(),
+                           location,
+                           scale.x,
+                           scale.y,
+                           scale.z,
+                           _volume->wAxis.max());
+        NanoVis::velocityArrowsSlice->axis(_sv.slicePos.axis);
+        NanoVis::velocityArrowsSlice->slicePos(_sv.slicePos.value);
+        NanoVis::velocityArrowsSlice->enabled(_sv.showArrows);
+    }
+
+    for (ParticlesHashmap::iterator itr = _particlesTable.begin();
+         itr != _particlesTable.end(); ++itr) {
+        itr->second->setVectorField(_volume,
+                                    location,
+                                    scale.x,
+                                    scale.y,
+                                    scale.z,
+                                    _volume->wAxis.max());
+    }
+    return true;
+}
+
+void
+Flow::renderBoxes()
+{
+    for (BoxHashmap::iterator itr = _boxTable.begin();
+         itr != _boxTable.end(); ++itr) {
+        if (itr->second->visible()) {
+            itr->second->render(_volume);
+        }
+    }
+}
+
+float *
+Flow::getScaledVector()
+{
+    assert(_data->nComponents() == 3);
+    size_t n = _data->nValues() / _data->nComponents() * 4;
+    float *data = new float[n];
+    if (data == NULL) {
+        return NULL;
+    }
+    memset(data, 0, sizeof(float) * n);
+    float *dest = data;
+    const float *values = _data->values();
+    for (size_t iz = 0; iz < _data->zNum(); iz++) {
+        for (size_t iy = 0; iy < _data->yNum(); iy++) {
+            for (size_t ix = 0; ix < _data->xNum(); ix++) {
+                double vx, vy, vz, vm;
+                vx = values[0];
+                vy = values[1];
+                vz = values[2];
+                vm = sqrt(vx*vx + vy*vy + vz*vz);
+                dest[0] = vm / NanoVis::magMax;
+                dest[1] = vx /(2.0*NanoVis::magMax) + 0.5;
+                dest[2] = vy /(2.0*NanoVis::magMax) + 0.5;
+                dest[3] = vz /(2.0*NanoVis::magMax) + 0.5;
+                values += 3;
+                dest += 4;
+            }
+        }
+    }
+    return data;
+}
+
+Volume *
+Flow::makeVolume(float *data)
+{
+    Volume *volume =
+        NanoVis::loadVolume(_name.c_str(),
+                            _data->xNum(),
+                            _data->yNum(), 
+                            _data->zNum(),
+                            4, data, 
+                            NanoVis::magMin, NanoVis::magMax, 0);
+    volume->xAxis.setRange(_data->xMin(), _data->xMax());
+    volume->yAxis.setRange(_data->yMin(), _data->yMax());
+    volume->zAxis.setRange(_data->zMin(), _data->zMax());
+
+    TRACE("min=%g %g %g max=%g %g %g mag=%g %g",
+          NanoVis::xMin, NanoVis::yMin, NanoVis::zMin,
+          NanoVis::xMax, NanoVis::yMax, NanoVis::zMax,
+          NanoVis::magMin, NanoVis::magMax);
+
+    volume->disableCutplane(0);
+    volume->disableCutplane(1);
+    volume->disableCutplane(2);
+
+    /* Initialize the volume with the previously configured values. */
+    volume->transferFunction(_sv.transferFunction);
+    volume->dataEnabled(_sv.showVolume);
+    volume->twoSidedLighting(_sv.twoSidedLighting);
+    volume->outline(_sv.showOutline);
+    volume->opacityScale(_sv.opacity);
+    volume->ambient(_sv.ambient);
+    volume->diffuse(_sv.diffuse);
+    volume->specularLevel(_sv.specular);
+    volume->specularExponent(_sv.specularExp);
+    volume->visible(_sv.showVolume);
+
+    Vector3f volScaling = volume->getPhysicalScaling();
+    Vector3f loc(volScaling);
+    loc *= -0.5;
+    volume->location(loc);
+
+    Volume::updatePending = true;
+    return volume;
+}
Index: /nanovis/branches/1.1/Flow.h
===================================================================
--- /nanovis/branches/1.1/Flow.h	(revision 4612)
+++ /nanovis/branches/1.1/Flow.h	(revision 4612)
@@ -0,0 +1,255 @@
+/* -*- mode: c++; c-basic-offset: 4; indent-tabs-mode: nil -*- */
+/*
+ * Copyright (c) 2004-2013  HUBzero Foundation, LLC
+ *
+ * Authors:
+ *   Wei Qiao <qiaow@purdue.edu>
+ *   Insoo Woo <iwoo@purdue.edu>
+ *   George A. Howlett <gah@purdue.edu>
+ *   Leif Delgass <ldelgass@purdue.edu>
+ */
+
+#ifndef FLOW_H
+#define FLOW_H
+
+#include <tr1/unordered_map>
+#include <vector>
+#include <string>
+
+#include <tcl.h>
+
+#include <vrmath/Vector3f.h>
+
+#include "Switch.h"
+#include "FlowTypes.h"
+#include "FlowParticles.h"
+#include "FlowBox.h"
+#include "NvLIC.h"
+#include "NvParticleRenderer.h"
+#include "Unirect.h"
+#include "Volume.h"
+#include "TransferFunction.h"
+
+struct FlowValues {
+    TransferFunction *transferFunction;
+    FlowPosition slicePos;
+    int showArrows;
+    int sliceVisible;
+    int showVolume;
+    int showOutline;
+    int isHidden;
+    int twoSidedLighting;
+    float ambient;     ///< Ambient volume shading
+    float diffuse;     ///< Diffuse volume shading
+    float specular;    ///< Specular level volume shading
+    float specularExp; ///< Specular exponent volume shading
+    float opacity;     ///< Volume opacity scaling
+};
+
+class Flow
+{
+public:
+    enum SliceAxis { AXIS_X, AXIS_Y, AXIS_Z };
+
+    Flow(Tcl_Interp *interp, const char *name);
+
+    ~Flow();
+
+    void getBounds(vrmath::Vector3f& min,
+                   vrmath::Vector3f& max,
+                   bool onlyVisible);
+
+    FlowParticles *createParticles(const char *particlesName);
+
+    FlowParticles *getParticles(const char *particlesName);
+
+    void deleteParticles(const char *particlesName);
+
+    void getParticlesNames(std::vector<std::string>& names);
+
+    void render();
+
+    void advect();
+
+    void resetParticles();
+
+    void initializeParticles();
+
+    FlowBox *createBox(const char *boxName);
+
+    FlowBox *getBox(const char *boxName);
+
+    void deleteBox(const char *boxName);
+
+    void getBoxNames(std::vector<std::string>& names);
+
+    float *getScaledVector();
+
+    Volume *makeVolume(float *data);
+
+    bool scaleVectorField();
+
+    bool visible()
+    {
+        return !_sv.isHidden;
+    }
+
+    const char *name() const
+    {
+        return _name.c_str();
+    }
+
+    bool isDataLoaded()
+    {
+        return (_data != NULL);
+    }
+
+    Rappture::Unirect3d *data()
+    {
+        return _data;
+    }
+
+    void data(Rappture::Unirect3d *data)
+    {
+        if (_data != NULL) {
+            delete _data;
+        }
+        _data = data;
+    }
+#if 0
+    void activateSlice()
+    {
+        /* Must set axis before offset or position goes to wrong axis. */
+        NanoVis::licRenderer->setAxis(_sv.slicePos.axis);
+        NanoVis::licRenderer->setOffset(_sv.slicePos.value);
+        NanoVis::licRenderer->active(true);
+    }
+
+    void deactivateSlice()
+    {
+        NanoVis::licRenderer->active(false);
+    }
+#endif
+    SliceAxis getAxis()
+    {
+        return (SliceAxis)_sv.slicePos.axis;
+    }
+
+    TransferFunction *getTransferFunction()
+    {
+        return _sv.transferFunction;
+    }
+
+    float getRelativePosition();
+
+    void setAxis()
+    {
+        NanoVis::licRenderer->setAxis(_sv.slicePos.axis);
+    }
+
+    void setAxis(Flow::SliceAxis axis)
+    {
+        _sv.slicePos.axis = axis;
+        NanoVis::licRenderer->setAxis(_sv.slicePos.axis);
+    }
+
+    void setCurrentPosition(float position)
+    {
+        _sv.slicePos.value = position;
+        NanoVis::licRenderer->setOffset(_sv.slicePos.value);
+    }
+
+    void setCurrentPosition()
+    {
+        NanoVis::licRenderer->setOffset(_sv.slicePos.value);
+    }
+
+    void setActive(bool state)
+    {
+        _sv.sliceVisible = state;
+        NanoVis::licRenderer->active(state);
+    }
+
+    void setActive()
+    {
+        NanoVis::licRenderer->active(_sv.sliceVisible);
+    }
+
+    const Volume *getVolume() const
+    {
+        return _volume;
+    }
+
+    int parseSwitches(Tcl_Interp *interp, int objc, Tcl_Obj *const *objv)
+    {
+        if (Rappture::ParseSwitches(interp, _switches, objc, objv, &_sv,
+                                    SWITCH_DEFAULTS) < 0) {
+            return TCL_ERROR;
+        }
+        return TCL_OK;
+    }
+
+    Tcl_Command getCommandToken()
+    {
+        return _cmdToken;
+    }
+
+    static float getRelativePosition(FlowPosition *pos);
+
+private:
+    typedef std::string ParticlesId;
+    typedef std::string BoxId;
+    typedef std::tr1::unordered_map<ParticlesId, FlowParticles *> ParticlesHashmap;
+    typedef std::tr1::unordered_map<BoxId, FlowBox *> BoxHashmap;
+
+    void configure();
+
+    void renderBoxes();
+
+    Tcl_Interp *_interp;
+    /**
+     * Name of the flow.  This may differ
+     * from the name of the command
+     * associated with the flow, if the
+     * command was renamed. */
+    std::string _name;
+
+    /**
+     * Command associated with the flow.
+     * When the command is deleted, so is
+     * the flow. */
+    Tcl_Command _cmdToken;
+
+    /**
+     * Uniform rectangular data
+     * representing the mesh and vector
+     * field values.  These values are
+     * kept to regenerate the volume
+     * associated with the flow. */
+    Rappture::Unirect3d *_data;
+
+    /**
+     * The volume associated with the
+     * flow.  This isn't the same thing as
+     * a normal volume displayed. */
+    Volume *_volume;
+
+    /**
+     * For each field there can be one or
+     * more particle injection planes
+     * where the particles are injected
+     * into the flow. */
+    ParticlesHashmap _particlesTable;
+
+    /**
+     * A table of boxes.  There maybe
+     * zero or more boxes associated
+     * with each field. */
+    BoxHashmap _boxTable;
+
+    FlowValues _sv;
+
+    static Rappture::SwitchSpec _switches[];
+};
+
+#endif
